Attribute VB_Name = "Functions"
' ChangeBackground 1.0.5 - Copyright (C)2004 Klaus Dahlenburg, INCOMM GmbH
' complete rework of coding affecting all modules. Published under the terms
' and conditions of GNU General Public License Version 2, 1991 or later
'
'
' ***************
' changes
' **************
'

Option Explicit

'Funktionsdeklaration Fenster im Vordergrund
Private Declare Function SetWindowPos Lib "User32" _
    (ByVal hWnd As Long, ByVal Order As Long, ByVal x As Long, _
    ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, _
    ByVal Flags As Long) As Long
'Funktionsdeklaration Programm oder Datei ffnen
Private Declare Function ShellExecute Lib "Shell32.dll" Alias _
    "ShellExecuteA" (ByVal hWnd As Long, ByVal lpOperation _
    As String, ByVal lpFile As String, ByVal lpParameters _
    As String, ByVal lpDirectory As String, ByVal nShowCmd _
    As Long) As Long
Public Enum SHOWCMDFLAGS
    SHOWNORMAL = 5
    SHOWMAXIMIZE = 3
    SHOWMINIMIZE = 7
    SHOWOK = 33
End Enum

Private lLogFile As Long
Private bNolog As Boolean
'
'VB 's Trim function only trims space characters (" ") from the beginning or the end of a string.
'This alternative trims all nonprinting characters (tabs, character returns, etc.)
'This Function ist from: www.codetoad.com
Public Function TrimComplete(ByVal sValue As String) As String

        Dim sAns As String
        Dim sWkg As String
        Dim sChar As String
        Dim lLen As Long
        Dim lCtr As Long

        sAns = sValue
        lLen = Len(sValue)

        If lLen > 0 Then
            'Ltrim
            For lCtr = 1 To lLen
                sChar = Mid(sAns, lCtr, 1)
                If Asc(sChar) > 32 Then Exit For
            Next

            sAns = Mid(sAns, lCtr)
            lLen = Len(sAns)

            'Rtrim
            If lLen > 0 Then
                For lCtr = lLen To 1 Step -1
                    sChar = Mid(sAns, lCtr, 1)
                    If Asc(sChar) > 32 Then Exit For
                Next
            End If
            sAns = Left$(sAns, lCtr)
        End If

        TrimComplete = sAns

End Function
'
' universal function to check field contents. The passed rule
' governs the extent of checking
'
Function chkFld(sData As String, chkVal As String) As Boolean

Dim tmp As Long
'
' value passed will be checked according to the rule given as chkVal
'
    If chkVal = vbNullString Then   ' no checking; avoids diff. calls
        chkFld = True
        Exit Function
    End If
    '
    chkFld = False
    Select Case UCase(chkVal)
        '
        ' "E" = field must not be empty
        '
        Case "E"
            If Trim$(sData) <> vbNullString Then
                chkFld = True
            End If
        '
        ' "N" = numeric, "NP" = numeric and > 0, "NPZ" = numeric >=0
        '
        Case "N", "NP", "NPZ"
            If IsNumeric(sData) Then
                If (CSng(sData) > 0 And chkVal = "NP") Then
                    chkFld = True
                Else
                    If (CSng(sData) >= 0 And chkVal = "NPZ") Then
                        chkFld = True
                    Else
                        If (chkVal = "N") Then
                            chkFld = True
                        End If
                    End If
               End If
            End If
        '
        ' "NI" = integer, "NPI" = integer and > 0, "NPZI" = integer and >=0
        '
        Case "NI", "NPI", "NPZI"
            If IsNumeric(sData) Then
                tmp = CLng(sData)
                If CDbl(sData) = tmp Then
                    If (tmp > 0 And chkVal = "NPI") Then
                        chkFld = True
                    Else
                        If (tmp >= 0 And chkVal = "NPZI") Then
                            chkFld = True
                        Else
                            If (chkVal = "NI") Then
                               chkFld = True
                            End If
                        End If
                    End If
                End If
            End If
        '
        ' unknown function code
        '
        Case Else
            ' normally it's an invalid call but ...
            ' treat field as valid
            chkFld = True
    End Select
    
End Function
'Die Funktion SetTopMost setzt ein Form
'vor alle anderen Fenster und Forms in den Vordergrund,
'auch wenn es nicht das aktive Fenster ist
'http://www.aboutvb.de/khw/artikel/khwtopmost.htm

Public Function SetTopMost(AnyForm As Form, _
 Optional ByVal State As Boolean = True, _
 Optional ByVal Activate As Boolean = True) As Boolean
  Dim nFlags As Long
  Dim nTopMode As Long
  
  Const SWP_NOMOVE = 2
  Const SWP_NOSIZE = 1
  Const HWND_TOPMOST = -1
  Const HWND_NOTOPMOST = -2
  Const SWP_NOACTIVATE = &H10

  nFlags = SWP_NOMOVE Or SWP_NOSIZE
  If Not Activate Then
    nFlags = nFlags Or SWP_NOACTIVATE
  End If
  Select Case State
    Case True
      nTopMode = HWND_TOPMOST
    Case False
      nTopMode = HWND_NOTOPMOST
  End Select
  SetTopMost = _
   CBool(SetWindowPos(AnyForm.hWnd, nTopMode, 0, 0, 0, 0, nFlags))
End Function
'
Public Function showFile(AnyForm As Form, sFilePath As String) As Long
    '
    ' try to open a file via ShellExecute first (rc <= 32 denotes error)
    '
    showFile = ShellExecute(AnyForm.hWnd, _
                vbNullString, _
                sFilePath, _
                vbNullString, _
                vbNullString, _
                SHOWNORMAL)
    '
End Function
'
Public Function openLog(pLogPath As String, Optional pAppend As Boolean = True) As Boolean
' original coding by J.Niesner
'
    openLog = False
    If lLogFile < 1 Then
        lLogFile = FreeFile          ' freie file nummer fuer Log Nummer holen
    End If
    If Not pAppend Then
        On Error GoTo seLogPath_error         ' check if blocked
        Open pLogPath For Output As #lLogFile  'Datei ffnen
    Else
        Open pLogPath For Append As #lLogFile  'Datei ffnen
    End If
    openLog = True
    Err.Clear
    Exit Function
'
seLogPath_error:
    MsgBox "Log Openerror Code: " & Err.Number & " Description: " & Err.Description _
            & vbNewLine & "Log suspended", vbInformation
    bNolog = True
    Err.Clear
'
End Function

Public Sub logWrite(ByVal sInfo As String)
' original coding by J.Niesner
'
    If Not bNolog Then
        Print #lLogFile, sInfo                     'Info in Datei schreiben
    End If
'
End Sub

Public Sub closeLog()
'
    On Error Resume Next
    If Not bNolog Then
        Close #lLogFile
        lLogFile = 0
    End If
'
End Sub

